/* Generated by tpc version 0.6.1 */

#define IS_ERROR(action) ((action) == 0)
#define IS_ACCEPT(action) ((action) == 57)
#define IS_REDUCE(action) (0 < (action) && (action) < 24)
#define IS_SHIFT(action) (24 <= (action) && (action) < 57)
#define REDUCTION(action) (action)
#define REDUCE_GOTO(state, production) \
    (goto_table[state][production -> nonterm_type])
#define SHIFT_GOTO(action) ((action) - 24)

typedef enum
{
    TT_EOF = 0,
    TT_WS,
    TT_WORD,
    TT_AT_WORD,
    TT_LBRACE,
    TT_RBRACE,
    TT_LF
} terminal_t;

struct production
{
    reduction_t reduction;
    int nonterm_type;
    int count;
};

static struct production productions[24] =
{
    /* 0: <file> ::= <text> */
    { identity, 0, 1 },

    /* 1: <text> ::= <item-list> */
    { identity, 1, 1 },

    /* 2: <text> ::= <item-list> <lf-list> */
    { identity2, 1, 2 },

    /* 3: <text> ::= <lf-list> */
    { identity, 1, 1 },

    /* 4: <item-list> ::= <item-list> <lf-list> <item> */
    { append_lf_and_item, 2, 3 },

    /* 5: <item-list> ::= <item-list> <item> */
    { append_item, 2, 2 },

    /* 6: <item-list> ::= <lf-list> <item> */
    { identity2, 2, 2 },

    /* 7: <item-list> ::= <item> */
    { identity, 2, 1 },

    /* 8: <item> ::= WS */
    { item_from_ws, 4, 1 },

    /* 9: <item> ::= WORD */
    { item_from_word, 4, 1 },

    /* 10: <item> ::= AT_WORD LBRACE <item-list> RBRACE */
    { item_from_curly, 4, 4 },

    /* 11: <item> ::= AT_WORD LBRACE RBRACE */
    { item_from_noarg_curly, 4, 3 },

    /* 12: <item> ::= <command> */
    { item_from_cmd, 4, 1 },

    /* 13: <lf-list> ::= <lf-list> LF */
    { extend_lf_list, 3, 2 },

    /* 14: <lf-list> ::= LF */
    { make_lf_list, 3, 1 },

    /* 15: <command> ::= AT_WORD <cmd-item-list> LF */
    { make_cmd, 5, 3 },

    /* 16: <command> ::= AT_WORD LF */
    { make_noarg_cmd, 5, 2 },

    /* 17: <cmd-item-list> ::= <cmd-item-list> <cmd-item> */
    { append_item, 6, 2 },

    /* 18: <cmd-item-list> ::= <cmd-item> */
    { make_cmd_item_list, 6, 1 },

    /* 19: <cmd-item> ::= WS */
    { item_from_ws, 7, 1 },

    /* 20: <cmd-item> ::= WORD */
    { item_from_word, 7, 1 },

    /* 21: <cmd-item> ::= AT_WORD LBRACE <cmd-item-list> RBRACE */
    { item_from_curly, 7, 4 },

    /* 22: <cmd-item> ::= AT_WORD LBRACE RBRACE */
    { item_from_noarg_curly, 7, 3 },

    /* 23: <cmd-item> ::= AT_WORD */
    { item_from_noarg_curly, 7, 1 }
};

#define ERR 0
#define ACC 57
#define R(x) (x)
#define S(x) (x + 24)

static unsigned int sr_table[33][7] =
{
    { ERR, S(6), S(7), S(8), ERR, ERR, S(9) },
    { ACC, ERR, ERR, ERR, ERR, ERR, ERR },
    { R(1), S(6), S(7), S(8), ERR, ERR, S(9) },
    { R(3), S(6), S(7), S(8), ERR, ERR, S(13) },
    { R(7), R(7), R(7), R(7), ERR, R(7), R(7) },
    { R(12), R(12), R(12), R(12), ERR, R(12), R(12) },
    { R(8), R(8), R(8), R(8), ERR, R(8), R(8) },
    { R(9), R(9), R(9), R(9), ERR, R(9), R(9) },
    { ERR, S(16), S(17), S(18), S(19), ERR, S(20) },
    { R(14), R(14), R(14), R(14), ERR, ERR, R(14) },
    { R(2), S(6), S(7), S(8), ERR, ERR, S(13) },
    { R(5), R(5), R(5), R(5), ERR, R(5), R(5) },
    { R(6), R(6), R(6), R(6), ERR, R(6), R(6) },
    { R(13), R(13), R(13), R(13), ERR, ERR, R(13) },
    { ERR, S(16), S(17), S(18), ERR, ERR, S(23) },
    { ERR, R(18), R(18), R(18), ERR, R(18), R(18) },
    { ERR, R(19), R(19), R(19), ERR, R(19), R(19) },
    { ERR, R(20), R(20), R(20), ERR, R(20), R(20) },
    { ERR, R(23), R(23), R(23), S(24), R(23), R(23) },
    { ERR, S(6), S(7), S(8), ERR, S(27), S(9) },
    { R(16), R(16), R(16), R(16), ERR, R(16), R(16) },
    { R(4), R(4), R(4), R(4), ERR, R(4), R(4) },
    { ERR, R(17), R(17), R(17), ERR, R(17), R(17) },
    { R(15), R(15), R(15), R(15), ERR, R(15), R(15) },
    { ERR, S(16), S(17), S(18), ERR, S(29), ERR },
    { ERR, S(6), S(7), S(8), ERR, S(31), S(9) },
    { ERR, S(6), S(7), S(8), ERR, ERR, S(13) },
    { R(11), R(11), R(11), R(11), ERR, R(11), R(11) },
    { ERR, S(16), S(17), S(18), ERR, S(32), ERR },
    { ERR, R(22), R(22), R(22), ERR, R(22), R(22) },
    { ERR, S(6), S(7), S(8), ERR, ERR, S(13) },
    { R(10), R(10), R(10), R(10), ERR, R(10), R(10) },
    { ERR, R(21), R(21), R(21), ERR, R(21), R(21) }
};

#undef ERR
#undef R
#undef S

static unsigned int goto_table[33][8] =
{
    { 0, 1, 2, 3, 4, 5, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 10, 11, 5, 0, 0 },
    { 0, 0, 0, 0, 12, 5, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 14, 15 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 21, 5, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 22 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 25, 26, 4, 5, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 28, 15 },
    { 0, 0, 0, 30, 11, 5, 0, 0 },
    { 0, 0, 0, 0, 12, 5, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 22 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 21, 5, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 }
};

